#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<algorithm>
#include<map>

#define MAXN 1000000
#define MAXM 10000000

using namespace std;

struct edge { int u, v; } G[MAXM];
class edgecompare
{
	public:
		bool operator() (edge a, edge b) {
			if (a.u < b.u)
				return true;
			if (a.u == b.u && a.v < b.v)
				return true;
			return false;
		}
};

//dane N a M, vypis do souboru s nazvem output
void gen_size (int N, int M)
{
	int m = 0;
	map<edge, int, edgecompare> MAP;
	int threshold = 0;
	while (m < M && threshold < 1000000) {
		edge e = { rand() % N, rand() % N };
		if (e.u != e.v) {		
			G[m++] = e;
			if (e.u > e.v)
				swap(e.u, e.v);
			if (MAP.find(e) == MAP.end()) {
				MAP[e] = 1;
				threshold = 0;
			}
			else {
				m--;
				threshold++;
			}
		}
	}
}


static int father[MAXN];

static int
root (int v)
{
  int r = v, a;

  while (father[r] != -1)
    r = father[r];

  while (father[v] != -1)
    {
      a = father[v];
      father[v] = r;
      v = a;
    }

  return r;
}

static void
join (int u, int v)
{
  int ru = root (u);
  int rv = root (v);

  if (ru != rv)
    father[ru] = rv;
}

static int
connected (int N, int M)
{
  int i, nm;

  for (i = 0; i < N; i++)
    father[i] = -1;

  for (i = 0; i < M; i++)
    join (G[i].u, G[i].v);

  nm = 0;
  for (i = 0; i < N; i++)
    if (father[i] == -1)
      nm++;

  return nm == 1;
}

void size_given(int N, int M, const char* output)
{
  do
    {
      gen_size (N, M);
    }
  while (!connected (N, M));

  FILE *f = fopen(output, "w");
  fprintf(f, "%d %d\n", N, M);
  for (int i = 0; i < M; i++)
    fprintf(f, "%d %d\n", G[i].u + 1, G[i].v + 1);
  fclose(f);
}

static int
perm[MAXN];

static void
pathlike (int n, int delta, const char *name)
{
  int i, j, m;
  FILE *fout = fopen (name, "w");

  for (i = 0; i < n; i++)
    perm[i] = i;
  for (i = 0; i < n; i++)
    {
      int with =  i + rand () % (n - i);
      int tmp = perm[i];
      perm[i] = perm[with];
      perm[with] = tmp;
    }

  m = 0;
  for (i = 0; i < n; i++)
    {
      j = i - delta;
      if (j < 0)
	j = 0;
    for (; j < i; j++)
      {
	G[m].u = perm[j];
	G[m].v = perm[i];
	m++;
      }
    }
  for (i = 0; i < m; i++)
    {
      int with =  i + rand () % (m - i);
      struct edge tmp = G[i];
      G[i] = G[with];
      G[with] = tmp;
    }
  fprintf (fout, "%d %d\n", n, m);
  for (i = 0; i < m; i++)
    fprintf(fout, "%d %d\n", G[i].u + 1, G[i].v + 1);
  fclose (fout);
}

int main()
{
	srand(0);
	pathlike (1,1, "01.in");
	pathlike (10,1, "02.in");
	pathlike (1000,8, "03.in");
	size_given (200, 10000, "04.in");
	size_given (1000,8000, "05.in");
	pathlike (100000,2, "06.in");
	pathlike (100000,8, "07.in");
	pathlike (200000,8, "08.in");
	size_given (100000,500000, "09.in");
	size_given (200000,1200000, "10.in");
	return 0;
}
